Package: biwt
Type: Package
Title: Compute the Biweight Mean Vector and Covariance & Correlation
        Matrice
Version: 1.0.1
Date: 2022-06-13
Author: Jo Hardin <jo.hardin@pomona.edu>
Maintainer: Jo Hardin <jo.hardin@pomona.edu>
Depends: R (>= 2.1.0), robustbase, MASS
Description: Compute multivariate location, scale, and correlation
        estimates based on Tukey's biweight M-estimator.
License: GPL-2
LazyLoad: yes
Packaged: 2022-06-13 15:27:50 UTC; jsh04747
Repository: CRAN
Date/Publication: 2022-06-13 15:50:02 UTC
NeedsCompilation: no
Built: R 4.3.3; ; 2025-01-24 14:52:58 UTC; unix

Package: biwt
Type: Package
Title: Compute the Biweight Mean Vector and Covariance & Correlation
        Matrice
Version: 1.0.1
Date: 2022-06-13
Author: Jo Hardin <jo.hardin@pomona.edu>
Maintainer: Jo Hardin <jo.hardin@pomona.edu>
Depends: R (>= 2.1.0), robustbase, MASS
Description: Compute multivariate location, scale, and correlation
        estimates based on Tukey's biweight M-estimator.
License: GPL-2
LazyLoad: yes
Packaged: 2022-06-13 15:27:50 UTC; jsh04747
Repository: CRAN
Date/Publication: 2022-06-13 15:50:02 UTC
NeedsCompilation: no
Built: R 4.6.0; ; 2026-04-25 23:58:40 UTC; unix

# Default NAMESPACE created by R
# Remove the previous line if you edit this file

# Export all names
exportPattern(".")

# Import all packages listed as Imports or Depends
import(
  robustbase,
  MASS
)

importFrom("stats", "dchisq", "mad", "mahalanobis", "pchisq")
importFrom("robustbase", "covMcd")

rejpt.bw <-
function(p,r){ # gives c1 = ARP  
    c1 <- 2*p
    iter <- 1
    crit <- 100
    eps <- 1e-5
    while ((crit > eps)&(iter<100)){  
c1.old <- c1
        fc <- erho.bw(p,c1) - c1^2*r/6
        fcp <- erho.bw.p(p,c1) - c1*r/3
        c1 <- c1 - fc/fcp
        if (c1 < 0)  c1 <- c1.old/2
        crit <- abs(fc)
        iter <- iter+1    }
    return(c(c1,pchisq(c1^2,p),log10(1-pchisq(c1^2,p))))}

`biwt.cor` <-
function(x,r=.2,output="matrix",median=TRUE,full.init=TRUE,absval=TRUE){

if (full.init==TRUE){

	rand.samp <-x[sample(1:nrow(x),2),]
        if (median != TRUE) {
            med.init <- covMcd(t(rand.samp))
        }
        else {
            med.init <- list()
            med.init$cov <- diag(1, 2) * (apply(rand.samp, 1, mad, na.rm = TRUE))^2
            med.init$center <- c(1, 1) * apply(rand.samp, 1, median, na.rm = TRUE)
		}
	}

	corr <- c()
	g <- dim(x)[1]

if(output=="matrix"){

for(i in 1:g){
	j <- 1
	while(j < i){

if (full.init !=TRUE){ 

	if (median!=TRUE) {med.init<-covMcd(cbind(x[i,],x[j,]))}
	else		{med.init<-list()
			med.init$cov <- diag(1,2)*(apply(cbind(x[i,],x[j,]),2,mad,na.rm=TRUE))^2
			med.init$center <- apply(cbind(x[i,],x[j,]),2,median,na.rm=TRUE)}
	}

	biwt <- biwt.est(rbind(x[i,],x[j,]),r,med.init)
	corr <- c(corr,biwt$biwt.sig[1,2]/sqrt(biwt$biwt.sig[1,1]*biwt$biwt.sig[2,2]))
	j<-j+1
	} 

	}

corr.mat <- vect2diss(corr)
diag(corr.mat) <- 1


return(corr.mat)}


if(output=="distance"){


for(i in 1:g){
	j <- 1
	while(j < i){

if (full.init !=TRUE){ 

	if (median!=TRUE) {med.init<-covMcd(cbind(x[i,],x[j,]))}
	else		{med.init<-list()
			med.init$cov <- diag(1,2)*(apply(cbind(x[i,],x[j,]),2,mad,na.rm=TRUE))^2
			med.init$center <- apply(cbind(x[i,],x[j,]),2,median,na.rm=TRUE)}
	}

	biwt <- biwt.est(rbind(x[i,],x[j,]),r,med.init)
	corr <- c(corr,biwt$biwt.sig[1,2]/sqrt(biwt$biwt.sig[1,1]*biwt$biwt.sig[2,2]))
	j<-j+1
	} 

	}

if(absval==TRUE){dist.mat <- vect2diss(1 - abs(corr))}
else {dist.mat <- vect2diss(1 - corr)}

diag(dist.mat) <- 0

return(dist.mat)}

if(output=="vector"){

for(i in 1:g){
	j <- 1
	while(j < i){

if (full.init !=TRUE){ 

	if (median!=TRUE) {med.init<-covMcd(cbind(x[i,],x[j,]))}
	else		{med.init<-list()
			med.init$cov <- diag(1,2)*(apply(cbind(x[i,],x[j,]),2,mad,na.rm=TRUE))^2
			med.init$center <- apply(cbind(x[i,],x[j,]),2,median,na.rm=TRUE)}
	}

	biwt <- biwt.est(rbind(x[i,],x[j,]),r,med.init)
	corr <- c(corr,biwt$biwt.sig[1,2]/sqrt(biwt$biwt.sig[1,1]*biwt$biwt.sig[2,2]))
	j<-j+1
	} 

	}
return(corr)}
}

vect2diss <- 
function (v) 
# This function is very similar to 
# dissmatrix in the hopach package
# except that it fills in by the lower
# triangle of the matrix instead of the
# upper triangle

{
    if (!is.vector(v)) 
        stop("arg to dissmatrix() must be a vector")
    p <- (1 + sqrt(1 + 8 * length(v)))/2
    M <- matrix(0, nrow = p, ncol = p)
    count <- 1
    for (i in 1:(p - 1)) {
        M[(i+1), 1:i] <- v[count:(count + i - 1)]
        count <- count + i
    }
    return(M + t(M))
}

ksolve <-
function(d,p,c1,b0){
    k <- 1
    iter <- 1
    crit <- 100
    eps <- 1e-10
    while ((crit > eps)&(iter<100)){
    k.old <- k
        fk <- mean(rhobw(d/k,c1),na.rm=TRUE)-b0
        fkp <- -mean(psibw(d/k,c1)*d/k^2,na.rm=TRUE)
if (fkp==0) {k<-NA
return(k)
stop("no values close enough")}
        k <- k - fk/fkp
        if (k < 0)  k <- k.old/2
        crit <- abs(k-k.old)
        iter <- iter+1    }
    return(k) }

`biwt.est` <-
function(x,r=.2,med.init=covMcd(x)){

p<-2
n <- dim(x)[2]
c1<-rejpt.bw(p=2,r)[1]
b0<-erho.bw(p=2,c1)[1]

x<-t(x)

d <- sqrt(mahalanobis(x,med.init$center,med.init$cov))
k <- ksolve(d,p,c1,b0)

if(is.na(k)) {  
med.init <- covMcd(x)
d <- sqrt(mahalanobis(x,med.init$center,med.init$cov))
k <- ksolve(d,p,c1,b0)}
# MCD is a more robust estimate of the center/shape
# than the median which is sometimes used


eps <- 1e-5
crit <- 100
iter <- 1
while (crit > eps & iter < 100) {
d <- d/k
biwt.mu <- apply(wtbw(d,c1)*x,2,sum,na.rm=TRUE) / sum (wtbw(d,c1),na.rm=TRUE)
cent <- array(dim=c(n,p,p))
for (i in 1:n){
cent[i,,] <- (x[i,] - biwt.mu)%*%t(x[i,]-biwt.mu)}
biwt.sig <- apply(cent*wtbw(d,c1),c(2,3),sum,na.rm=TRUE)/
sum(vbw(d,c1),na.rm=TRUE) 


d2 <- sqrt(mahalanobis(x,biwt.mu,biwt.sig))
k <- ksolve(d2,p,c1,b0)
crit <- max(abs(d-(d2/k)),na.rm=TRUE)
d <- d2
iter <-  iter+1}

return(list(biwt.mu=biwt.mu,biwt.sig=biwt.sig))}

\name{biwtInternalFunctions}
\alias{biwtInternalFunctions}
\alias{chi.int2.p}
\alias{chi.int2}
\alias{chi.int.p}
\alias{chi.int}
\alias{erho.bw.p}
\alias{erho.bw}
\alias{ksolve}
\alias{psibw}
\alias{rejpt.bw}
\alias{rhobw}
\alias{vbw}
\alias{wtbw}
\alias{vect2diss}

%- Also NEED an '\alias' for EACH other topic documented here.
\title{Functions used internally for the biwt package }
\description{
Tukey's biweight gives robust estimates of a p-dimensional mean vector and covariance matrix.  These functions are used internally within the biweight estimation function.
}
\usage{
chi.int2.p(p, a, c1)
chi.int2(p,a,c1)
chi.int.p(p,a,c1)
chi.int(p,a,c1)
erho.bw.p(p,c1)
erho.bw(p,c1)
ksolve(d,p,c1,b0)
psibw(x,c1)
rhobw(x,c1)
vbw(x,c1)
wtbw(x,c1)
rejpt.bw(p,r)
vect2diss(v)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{p}{ the dimension of the data (should be two if computing correlations. Unlike Pearson correlation, pairwise correlations will not be the same if computed on the entire data set as compared to one pair at a time.) }
  \item{a}{ degrees of freedom for the chi square distribution}
  \item{c1}{ cutoff value at which the biweight function gives zero weight to any data point}
  \item{d}{ vector of distances from each data point to mean vector}
  \item{b0}{ expected value of the \eqn{\rho} function for the biweight estimator (under normality)}
  \item{x}{ value at which the biweight (\eqn{\rho, \psi, v, w}) should be evaluated}
  \item{r}{breakdown (\eqn{k/n} where \eqn{k} is the largest number of observations that can be replaced with arbitrarily large values while keeping the estimates bounded)}
  \item{v}{a vector (presumably from \code{biwt.cor}) consisting of the lower triangle of a symmetric dissimilarity or similarity matrix}   
}
\details{
These functions are used internally for the \code{\link{biwt.est}} and \code{\link{biwt.cor}} functions in the \code{\link{biwt}} package.
}
\value{
The following functions evaluate partial integrals of the \eqn{\chi^2} distribution: \code{chi.int}, \code{chi.in2}, \code{chi.int.p}, \code{chi.int2.p}.

The following functions evaluate the biweight functions: \code{psibw}, \code{rhobw}, \code{wbw}, \code{vbw}.

The following functions caluclate the expected value of the \eqn{\rho} function under the assumption of normally distribued data: \code{erho.bw}, \code{erho.bw.p}.

The function \code{ksolve} keeps the estimates from imploding by setting the mean value of \eqn{\rho} equal to its expected value under normality.

The function \code{rejpt.bw} gives the asymptotic rejection point.

The function \code{vect2diss} converts a vector consisting of a lower triangle of a matrix into a symmetric dissimilarity or similarity matrix.  The function is similar to \code{dissmatrix} in the \code{hopach} package, except that \code{vect2diss} fills in the lower triangle first while \code{dissmatrix} fills in the upper triangle first.

}
\references{ Hardin, J., Mitani, A., Hicks, L., VanKoten, B.; \bold{A Robust Measure of Correlation Between Two Genes on a Microarray}, \emph{BMC Bioinformatics}, \bold{8}:220; 2007.   }
\author{Jo Hardin \email{jo.hardin@pomona.edu}}

\seealso{ \code{\link{biwt.est}} , \code{\link{biwt.cor}}}
\examples{
## These are not user level functions
## See examples for biwt.est or biwt.cor
## ?biwt.est
## ?biwt.cor

}

\name{biwt-package}
\Rdversion{1.1}
\alias{biwt-package}
\alias{biwt}
\docType{package}
\title{
A package to compute the biweight mean vector and covariance & correlation matrices}
\description{
Compute multivariate location, scale, and correlation estimates based on Tukey's biweight weight function.
}
\details{
\tabular{ll}{
Package: \tab biwt\cr
Type: \tab Package\cr
Version: \tab 1.0\cr
Date: \tab 2009-07-20\cr
License: \tab GPL-2\cr
LazyLoad: \tab yes\cr
}

The two basic functions (1) calculate multivariate estimates of location and shape based on Tukey's biweight, and (2) compute correlations based on the biweight.  The correlation functions also have options to output the data as a correlation matrix or a distance matrix (typically one minus the correlation or one minus the absoulte correlation).  Once the output is in a distance matrix, it can easily be converted (as.dist() ) to an object of the class "dist" which stores the lower triangle of the correlation matrix in a vector.  Many clustering algorithms take as input objects of the class "dist".


}
\author{
Jo Hardin \email{jo.hardin@pomona.edu}

Maintainer: Jo Hardin \email{jo.hardin@pomona.edu}
}
\references{
Hardin, J., Mitani, A., Hicks, L., VanKoten, B.; \bold{A Robust Measure of Correlation Between Two Genes on a Microarray}, \emph{BMC Bioinformatics}, \bold{8}:220; 2007. 
}

\keyword{robust}
\keyword{multivariate}
\keyword{cluster}
%\keyword{biweight}
%\keyword{correlation}
%\keyword{Tukey}

\seealso{
\code{\link{biwt.est}}, \code{\link{biwt.cor}}
}
\examples{

### To calculate the multivariate location vector and scale matrix:

samp.data <- t(mvrnorm(30,mu=c(0,0),Sigma=matrix(c(1,.75,.75,1),ncol=2)))

samp.bw <- biwt.est(samp.data)
samp.bw

samp.bw.var1 <- samp.bw$biwt.sig[1,1]
samp.bw.var2 <- samp.bw$biwt.sig[2,2]
samp.bw.cov <- samp.bw$biwt.sig[1,2]

samp.bw.cor <- samp.bw$biwt.sig[1,2] / 
	sqrt(samp.bw$biwt.sig[1,1]*samp.bw$biwt.sig[2,2])
samp.bw.cor


### To calculate the correlation(s):


samp.data <- t(mvrnorm(30,mu=c(0,0,0),
	Sigma=matrix(c(1,.75,-.75,.75,1,-.75,-.75,-.75,1),ncol=3)))

# To compute the 3 pairwise correlations from the sample data:

samp.bw.cor <- biwt.cor(samp.data, output="vector")
samp.bw.cor

# To compute the 3 pairwise correlations in matrix form:

samp.bw.cor.mat <- biwt.cor(samp.data)
samp.bw.cor.mat

# To compute the 3 pairwise distances in matrix form:

samp.bw.dist.mat <- biwt.cor(samp.data, output="distance")
samp.bw.dist.mat

# To convert the distances into an object of class `dist'

as.dist(samp.bw.dist.mat)

}
